// (c) Copyright 2011-2013 Cloudera, Inc. All rights reserved.
define([
  'cloudera/cmf/include/ServiceChartsV2',
  'cloudera/Util'
], function(ServiceChartsV2, Util) {
  describe("ServiceChartsV2 Tests", function() {
    var id = "resetView", module, options = {
      resetButtonSelector: "#" + id,
      resetUrl: "dontcare"
    };

    beforeEach(function() {
      $("<div>").attr("id", id).appendTo(document.body);
      jasmine.Ajax.useMock();
      clearAjaxRequests();
    });

    afterEach(function() {
      $("#" + id).remove();
    });

    it("should test the reset button.", function() {
      spyOn(window, "confirm").andReturn(true);
      spyOn(Util, "reloadPage");

      module = new ServiceChartsV2(options);
      $("#" + id).trigger("click");

      var request = mostRecentAjaxRequest();
      request.response({
        status: 200,
        responseText: '{"message":"OK", "data":null}'
      });

      expect(Util.reloadPage).wasCalled();
    });

    it("should test the reset button and fail.", function() {
      spyOn(window, "confirm").andReturn(true);
      spyOn($, "publish");

      module = new ServiceChartsV2(options);
      $("#" + id).trigger("click");

      var request = mostRecentAjaxRequest();
      request.response({
        status: 200,
        responseText: '{"message":"Failed", "data":null}'
      });
      expect($.publish).wasCalledWith("showError", ["Failed"]);
    });
  });
});
